/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Describes a Virtual Machine Scale Set VM Reimage Parameters.
 *
 * @extends models['VirtualMachineScaleSetVMReimageParameters']
 */
class VirtualMachineScaleSetReimageParameters extends models['VirtualMachineScaleSetVMReimageParameters'] {
  /**
   * Create a VirtualMachineScaleSetReimageParameters.
   * @member {array} [instanceIds] The virtual machine scale set instance ids.
   * Omitting the virtual machine scale set instance ids will result in the
   * operation being performed on all virtual machines in the virtual machine
   * scale set.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of VirtualMachineScaleSetReimageParameters
   *
   * @returns {object} metadata of VirtualMachineScaleSetReimageParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VirtualMachineScaleSetReimageParameters',
      type: {
        name: 'Composite',
        className: 'VirtualMachineScaleSetReimageParameters',
        modelProperties: {
          tempDisk: {
            required: false,
            serializedName: 'tempDisk',
            type: {
              name: 'Boolean'
            }
          },
          instanceIds: {
            required: false,
            serializedName: 'instanceIds',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = VirtualMachineScaleSetReimageParameters;
